Package ghidra.app.util.bin.format.swift.types

# Class TargetProtocolConformanceDescriptor

java.lang.Object
ghidra.app.util.bin.format.swift.SwiftTypeMetadataStructure
ghidra.app.util.bin.format.swift.types.TargetProtocolConformanceDescriptor

All Implemented Interfaces:
  `StructConverter`

public final class TargetProtocolConformanceDescriptor extends SwiftTypeMetadataStructure
Represents a Swift TargetProtocolConformanceDescriptor structure

See Also:
  - swift/ABI/Metadata.h

- ## Field Summary

  ### Fields inherited from class ghidra.app.util.bin.format.swift.SwiftTypeMetadataStructure

  `DATA_TYPE_CATEGORY`

  ### Fields inherited from interface ghidra.app.util.bin.StructConverter

  `ASCII, BYTE, DWORD, IBO32, IBO64, POINTER, QWORD, SLEB128, STRING, ULEB128, UTF16, UTF8, VOID, WORD`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TargetProtocolConformanceDescriptor(BinaryReader reader)`
  Creates a new `TargetProtocolConformanceDescriptor`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `getConformanceFlags()`
  Gets various flags, including the kind of conformance
  `String`
  `getDescription()`
  Gets a short description of the `SwiftTypeMetadataStructure`
  `int`
  `getNominalTypeDescriptor()`
  Gets some description of the type that conforms to the protocol
  `int`
  `getProtocolDescriptor()`
  Gets the protocol being conformed to
  `int`
  `getProtocolWitnessTable()`
  Gets the witness table pattern, which may also serve as the witness table
  `String`
  `getStructureName()`
  Gets the name of the `SwiftTypeMetadataStructure`
  `DataType`
  `toDataType()`
  Returns a structure datatype representing the contents of the implementor of this interface.

  ### Methods inherited from class ghidra.app.util.bin.format.swift.SwiftTypeMetadataStructure

  `getBase`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### TargetProtocolConformanceDescriptor

    public TargetProtocolConformanceDescriptor(BinaryReader reader) throws IOException
    Creates a new `TargetProtocolConformanceDescriptor`
    Parameters:
      `reader` - A `BinaryReader` positioned at the start of the structure
    Throws:
      `IOException` - if there was an IO-related problem creating the structure

- ## Method Details

  - ### getProtocolDescriptor

    public int getProtocolDescriptor()
    Gets the protocol being conformed to
    Returns:
      The protocol being conformed to

  - ### getNominalTypeDescriptor

    public int getNominalTypeDescriptor()
    Gets some description of the type that conforms to the protocol
    Returns:
      Some description of the type that conforms to the protocol

  - ### getProtocolWitnessTable

    public int getProtocolWitnessTable()
    Gets the witness table pattern, which may also serve as the witness table
    Returns:
      The witness table pattern, which may also serve as the witness table

  - ### getConformanceFlags

    public int getConformanceFlags()
    Gets various flags, including the kind of conformance
    Returns:
      Various flags, including the kind of conformance

  - ### getStructureName

    public String getStructureName()
    Description copied from class: `SwiftTypeMetadataStructure`
    Gets the name of the `SwiftTypeMetadataStructure`
    Specified by:
      `getStructureName` in class `SwiftTypeMetadataStructure`
    Returns:
      The name of the `SwiftTypeMetadataStructure`

  - ### getDescription

    public String getDescription()
    Description copied from class: `SwiftTypeMetadataStructure`
    Gets a short description of the `SwiftTypeMetadataStructure`
    Specified by:
      `getDescription` in class `SwiftTypeMetadataStructure`
    Returns:
      A short description of the `SwiftTypeMetadataStructure`

  - ### toDataType

    public DataType toDataType() throws DuplicateNameException, IOException
    Description copied from interface: `StructConverter`
    Returns a structure datatype representing the contents of the implementor of this interface.

    For example, given:

         class A {
             int foo;
             double bar;
         }

    The return value should be a structure data type with two data type components; an INT and a DOUBLE. The structure should contain field names and, if possible, field comments.

    Returns:
      returns a structure datatype representing the implementor of this interface
    Throws:
      `DuplicateNameException` - when a datatype of the same name already exists
      `IOException` - if an IO-related error occurs
    See Also:
      - `StructureDataType`